#!/bin/bash

#add to menus in all languages xdg support (and do not replace the original menu since it contains windowmaker-specific commands

for file in menu.*
do
#loop over a list of common programs, if a program is in the line - then delete it
    for prog_list in \
        firefox gimp ghostview xpdf abiword dia ooffice oowriter oocalc oodraw ooimpress xemacs emacs xjed "xterm -e vi" gvim nedit xedit xmms xine mplayer xv xpainy xfig xfm files lyx netscape "\/usr\/local\/Acrobat3\/bin\/acroread" tkdesk xfte xpaint xmcd xplaycd xmixer "xterm -T \"GNU plot\"" xephem xmupad xxgdb editres maze spider xboard xeyes xlogo xroach xtetris xvier xgas xkobo xboing xbill civ runxdos "xterm -T 'Joe'" xdvi "xterm -name mail" mule "kterm -e vi" gv xdvi xspread xwpe xminicom bitmap arena seyon workbone xlander xmahjongg "ULUB_TERM -e vi" "ULUB_TERM -T \"Midnight Commander\"" "ULUB_TERM -T \"GNU plot\"" "ULUB_TERM -e lynx" "ULUB_TERM -T \"Program pocztowy Pine\"" "ULUB_TERM -T \"Program pocztowy Elm\"" xmh "ULUB_TERM -e telnet" "ULUB_TERM -e ssh" "ULUB_TERM -e ftp" "ULUB_TERM -e irc" "ULUB_TERM -e ping" "ULUB_TERM -e talk"
    do
        sed -r "/EXEC $prog_list$/ d" -i $file
        sed -r "/EXEC $prog_list / d" -i $file
    done
#delete empty lines
    sed -r "/^(\t| )*$/ d" -i $file

#insert xdg menu
#1)determine "application" string in a language
    applications_lang=`cat $file|grep "\" WORKSPACE_MENU" -A 1|sed "/WORKSPACE_MENU/ d"|cut -d \" -f 2`
    
#exception for menu.es....
    [ "$file" = "menu.es" ] && applications_lang="Applications"
#2)put xdg menu just after the WORKSPACE_MENU entry
    sed -r "/\"( )*WORKSPACE_MENU/ a\
        \"$applications_lang\" OPEN_MENU \$(HOME)/GNUstep/Defaults/menu.xdg" -i $file

#fix for menu.pl, I don't know why it fails here
    [ "$file" = "menu.pl" ] && sed -r 's/\"\" OPEN_MENU/\"Aplikacje\" OPEN_MENU/' -i $file
    
#delete empty MENU-END entries (without elements inside)
#3x because empty menus can be nested
    sed '$!N;/ MENU.*\n.* END/d;P;D' -i $file
    sed '$!N;/ MENU.*\n.* END/d;P;D' -i $file
    sed '$!N;/ MENU.*\n.* END/d;P;D' -i $file

#fix WPrefs path in menus
    sed -r "s@/usr/local/GNUstep@/usr/GNUstep@g" -i $file
done
